import { MakeRequired, RSA, RSN } from "./utils";
import type { Validate } from "./validate";
export declare type Guard<Type, Options extends RSA = RSN> = Validate<Type> & ((options: Partial<Options>) => Validate<Type>);
export declare function guard<Type, Options extends RSA = RSN>(name: string, fn: (val: unknown, options: Partial<Options>) => boolean, handleOptions?: {
    [K in keyof Options]?: (val: Type, o: NonNullable<Options[K]>, options?: MakeRequired<Options, K>) => boolean;
}, defaultOptions?: {
    [K in keyof Options]?: Options[K];
}): Guard<Type, Options>;
