import { Guard } from "./guard";
import { Primitive, RSE } from "./utils";
declare global {
    namespace vality {
        interface guards {
            string: Guard<string, {
                minLength?: number;
                maxLength?: number;
                match?: RegExp;
            }>;
            number: Guard<number, {
                min?: number;
                max?: number;
                /**
                 * @default false
                 */
                integer?: boolean;
            }>;
            boolean: Guard<boolean>;
            /**
             * @example vality.literal(7)
             */
            literal<T extends Primitive>(lit: T): Guard<T>;
            /**
             * @example vality.relation(SomeModel)
             */
            relation<S extends () => RSE>(type: S): Guard<S>;
        }
    }
}
