"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.compose = exports.flat = exports.enyToGuardFn = exports.enyToGuard = exports.assert = void 0;
const symbols_1 = require("./symbols");
const validate_1 = require("./validate");
const vality_1 = require("./vality");
function assert(val, condition) {
    if (condition === false) {
        throw new Error("Assertion failed");
    }
}
exports.assert = assert;
function enyToGuard(eny) {
    if (Array.isArray(eny)) {
        if (eny.length === 0)
            throw new Error("Empty array valit");
        if (eny.length === 1)
            return vality_1.vality.array(enyToGuard(eny[0]));
        return vality_1.vality.enum(...eny.map(enyToGuard));
    }
    if (typeof eny === "string" || typeof eny === "number" || typeof eny === "boolean" || eny === null)
        return vality_1.vality.literal(eny);
    // Not sure why we have to assert here, a symbol should never be a key in RSA
    if (symbols_1._validate in eny)
        return eny;
    // This should only allow () => RSE at this point...
    if (typeof eny === "function")
        return vality_1.vality.relation(eny);
    // Not sure why we have to assert here, as RSA should be the only type left after narrowing
    return vality_1.vality.object(eny);
}
exports.enyToGuard = enyToGuard;
function enyToGuardFn(v) {
    return enyToGuard(v)[symbols_1._validate];
}
exports.enyToGuardFn = enyToGuardFn;
function flat(arr) {
    return [].concat(...arr);
}
exports.flat = flat;
function compose(...guards) {
    return (val) => guards.every(g => (0, validate_1.validate)(g, val).valid);
}
exports.compose = compose;
