import { _type, _validate, _valit, _virtual } from "./symbols";
import { Eny } from "./utils";
export interface Error {
    message: string;
    path: Path;
    options: any;
    value: any;
}
export declare type ValidationResult = {
    valid: boolean;
    errors: Error[];
};
export declare type Validate<T> = {
    [_validate]: ValidateFn;
    [_type]: T;
    [_virtual]?: false;
    [_valit]?: false;
};
export declare type ValidateFn = (val: unknown, path?: Path) => ValidationResult;
export declare type Path = (string | number)[];
export declare function validate(schema: Eny, val: unknown, bail?: boolean): ValidationResult;
