import { _valit, _virtual } from "./symbols";
import { MakeRequired, RSA, RSN } from "./utils";
import type { Path, Validate, ValidationResult } from "./validate";
export declare type Valitate<V> = {
    [_valit]?: typeof _valit;
} & Validate<V>;
export declare type Valit<V, Options extends RSA = RSN> = Valitate<V> & ((options: Partial<Options>) => Valitate<V>);
export declare type VirtualValit<T> = {
    [_virtual]?: typeof _virtual;
} & Valit<T>;
export declare function valit<Arg extends any[], Type, Options extends RSA = RSN>(name: string, fn: (...args: Arg) => (val: unknown, path: Path, options: Partial<Options>) => ValidationResult, handleOptions?: {
    [K in keyof Options]?: (val: Type, o: NonNullable<Options[K]>, options: MakeRequired<Options, K>) => boolean;
}, defaultOptions?: {
    [K in keyof Options]?: Options[K];
}): (...args: Arg) => Valit<Type, Options>;
