import { Eny } from "./utils";
import { Valit, VirtualValit } from "./valit";
declare global {
    namespace vality {
        interface valits {
            array: <E extends Eny>(e: E) => Valit<E[], {
                minLength?: number;
                maxLength?: number;
                /**
                 * If true, stops validating after the first error.
                 *
                 * @default false
                 */
                bail?: boolean;
            }>;
            tuple: <E extends Eny[]>(...es: E) => Valit<E>;
            optional: <E extends Eny>(e: E) => Valit<E | undefined>;
            enum: <E extends Eny[]>(...es: E) => Valit<E[number]>;
            object: <E extends Record<string, Eny>>(v: E) => Valit<E, {
                /**
                 * If true, stops validating after the first error.
                 *
                 * @default false
                 */
                bail?: boolean;
            }>;
            /**
             * This valit wraps the passed eny so that it is ignored by ParseIn
             */
            virtual: <E extends Eny>(e: E) => VirtualValit<E>;
        }
    }
}
